#!/usr/bin/env python3
"""
GISAS of cylinders on a 2D hexagonal paracrystal.

The paracrystal is isotropic (integration over xi), with a Cauchy
probability distribution function and 20 nm peak distance.
"""
import bornagain as ba
from bornagain import ba_plot as bp, deg, nm


def get_sample():
    particle_color = (0.86, 0.24, 0.18)
    particle_mat = ba.RefractiveMaterial("Particle", particle_color, 6e-4, 2e-8)
    substrate_color = (0.28, 0.57, 0.82)
    substrate_mat = ba.RefractiveMaterial("Substrate", substrate_color, 6e-6, 2e-8)
    vacuum = ba.Vacuum()

    ff = ba.Cylinder(5 * nm, 5 * nm)
    particle = ba.Particle(particle_mat, ff)

    lattice = ba.HexagonalLattice2D(20 * nm, 0)
    structure = ba.Paracrystal2D(particle, lattice, 0, 20e3 * nm, 20e3 * nm)
    structure.setIntegrationOverXi(True)
    profile = ba.Profile2DCauchy(150 * nm, 150 * nm, 0)
    structure.setProbabilityDistributions(profile, profile)

    vacuum_layer = ba.Layer(vacuum)
    substrate_layer = ba.Layer(substrate_mat)
    vacuum_layer.deposit2D(structure)

    sample = ba.Sample()
    sample.addLayer(vacuum_layer)
    sample.addLayer(substrate_layer)
    return sample


<%= include_partial("template/sim/gisas_standard_wide.py") -%>


<%= include_partial("template/main/runsim_unitaspect.py",
    "ba.showSample3D(sample, sample_size=300*nm, seed=0)") -%>
